/*
 * Copyright (c) 1993, 1994 by Chris Provenzano, proven@mit.edu
 * Copyright (c) 1995-1998 by John Birrell <jb@cimlogic.com.au>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *  This product includes software developed by Chris Provenzano.
 * 4. The name of Chris Provenzano may not be used to endorse or promote 
 *	  products derived from this software without specific prior written
 *	  permission.
 *
 * THIS SOFTWARE IS PROVIDED BY CHRIS PROVENZANO ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL CHRIS PROVENZANO BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE.
 *
 * NOTE:
 * This file extracts the FreeBSD rw headers from the FreeBSD pthread.h file.
 *
 */

#ifndef PTHREAD_RW_H
#define PTHREAD_RW_H

struct pthread_rwlock;
struct pthread_rwlockattr;

typedef struct	pthread_rwlock		*pthread_rwlock_t;
typedef struct	pthread_rwlockattr	*pthread_rwlockattr_t;

#define PTHREAD_RWLOCK_INITIALIZER	NULL

int		pthread_rwlock_destroy __P((pthread_rwlock_t *));
int		pthread_rwlock_init __P((pthread_rwlock_t *,
			const pthread_rwlockattr_t *));
int		pthread_rwlock_rdlock __P((pthread_rwlock_t *));
int		pthread_rwlock_tryrdlock __P((pthread_rwlock_t *));
int		pthread_rwlock_trywrlock __P((pthread_rwlock_t *));
int		pthread_rwlock_unlock __P((pthread_rwlock_t *));
int		pthread_rwlock_wrlock __P((pthread_rwlock_t *));
int		pthread_rwlockattr_init __P((pthread_rwlockattr_t *));
int		pthread_rwlockattr_getpshared __P((const pthread_rwlockattr_t *,
			int *));
int		pthread_rwlockattr_setpshared __P((pthread_rwlockattr_t *,
			int *));
int		pthread_rwlockattr_destroy __P((pthread_rwlockattr_t *));

#endif
